<?php

namespace Drupal\ump\Routing;

use Drupal\Core\Routing\RouteSubscriberBase;
use Symfony\Component\Routing\RouteCollection;

/**
 * Listens to the dynamic route events.
 */
class RouteSubscriber extends RouteSubscriberBase {

  /**
   * {@inheritdoc}
   */
  protected function alterRoutes(RouteCollection $collection) {
    // Define the custom access controllers.
    if ($route = $collection->get('user.admin_create')) {
      $route->setRequirements(['_custom_access' => '\Drupal\ump\Controller\AccessController::create']);
    }
    if ($route = $collection->get('entity.user.canonical')) {
      $route->setRequirements(['_custom_access' => '\Drupal\ump\Controller\AccessController::view']);
    }
    if ($route = $collection->get('entity.user.edit_form')) {
      $route->setRequirements(['_custom_access' => '\Drupal\ump\Controller\AccessController::edit']);
    }
    if ($route = $collection->get('entity.user.cancel_form')) {
      $route->setRequirements(['_custom_access' => '\Drupal\ump\Controller\AccessController::delete']);
    }
  }

}
